/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.fleet.machine.wizard;

import java.beans.PropertyEditor;
import java.beans.PropertyEditorSupport;
import java.lang.reflect.InvocationTargetException;
import java.util.logging.Logger;
import javax.swing.JLabel;
import javax.swing.JPanel;
import net.miginfocom.swing.MigLayout;
import nl.cloudfarming.client.fleet.model.MachinePropertyDefinition;
import org.openide.explorer.propertysheet.PropertyPanel;
import org.openide.nodes.Node;
import org.openide.nodes.Node.Property;

/**
 * This class represents a visual panel for a dynamic property form. It shows a
 * form with fields for its properties.
 *
 * @author Wytse Visser
 */
class MachineDynamicVisualPanel extends JPanel {

    /**
     * Creates new form MachineDynamicVisualPanel
     */
    public MachineDynamicVisualPanel() {
        setLayout(new MigLayout("wrap 2"));
    }

    /**
     * Add a new property field to this visual panel. The PropertyPanel class is
     * used to create this field, so the property editor is based on the
     * property type.
     *
     * @param property The property
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     */
    public void addPropertyField(Property property) throws IllegalAccessException, InvocationTargetException {
        add(new JLabel(property.getName()));
        add(new PropertyPanel(property), "width min:300:max");
    }
}
